; Autor : Jess Manuel Hernndez
; Fecha : Septiembre 1998
;
; Descipcin :
;
; Pone en pantalla ficheros .BMP de 32/24 bpp (sin compresion) de
;  cualquier resolucin. Hay que indicarle el modo VESA empleado. Tiene
;  que ser un modo con direccionamiento lineal (LFB)

biWidth    equ  4
biHeight   equ  8
biBitCount equ 14

BytesPerScanLine equ 16
BitsPerPixel     equ 25
PhysBasePtr      equ 40

[BITS 16]
; Segmento de CODIGO ------------------------------------------------------

[SEGMENT CODE]
[GLOBAL LoadBMP]
LoadBMP:
; El procedimiento LoadBMP se ocupa de cargar la imgen
; en formato BMP que est en el fichero cuyo nombre es apuntado.
;
; Entrada: DS:DX = Puntero al nombre del fichero.
;          EDI   = Direccion plana de donde guardar la imagen
; Salida:  CF = 0 Exito
;          CF = 1 ERROR
;
         push ds
         push es
         pushad
;         mov ax,_DATA
;         mov ds,ax
        ; Paso 1: Abro el fichero cuyo nombre ASCIIZ est en la direccin
        ;         DS:DX
         MOV AH,3Dh                        ; OPEN FILE
         MOV AL,00100000b                  ; Read Only + DENYWRITE
         INT 21h
         JNC  .c1
         jmp HuboError
.c1 	 mov [Handle],ax

	; Paso 2: Leo la cabecera FileHeader

         MOV BX,AX                       ; En BX est el Handle
         MOV AH,3Fh
         MOV CX,14                       ; Tamao
         MOV DX,FileHeader               ; DS:DX apunta al buffer
         INT 21h
         JNC TodoOK
 	 JMP HuboError

        ; Paso 3: Leo la cabecera InfoHeader

TodoOK:  MOV AH,3Fh
         MOV CX,40                       ; BX = Handle
         MOV DX,InfoHeader               ; DS:DX apunta al buffer
         INT 21h
         JNC Sigue
         JMP HuboError
Sigue:   cmp word [InfoHeader+biBitCount],24
         je  .sigue
         jmp HuboError

        ; Paso 4: Ahora leo la imgen. Las lneas de la imgen estn guarda-
        ;         das en orden inverso (lnea 199, lnea 198, ... ,lnea 0)

.sigue:  xor ax,ax
         mov es,ax                         ; Segmento destino FLAT model
         mov ax,_DATA
         mov ds,ax                         ; Segmento datos REAL-ADDR model
         mov ecx,[BPP]
         dec ecx
         mov eax,[InfoHeader+biWidth]
.s:      add eax,[InfoHeader+biWidth]
         loop .s
         mov [AnchuraX],eax                ; Anchura linea en pantalla
         mov ecx,[WIDTHX] ; InfoHeader.biWidth
         mov eax,[InfoHeader+biHeight]
         dec eax
         imul ecx
         xor ecx,ecx
         mov ecx,[BPP]
         dec ecx
         mov ebx,eax
.s2:     add eax,ebx
         loop .s2
         add edi,eax                       ; Lo pongo al final de la pantalla
         mov ecx,[InfoHeader+biHeight]     ; El total de lineas a leer
         MOV BX,[Handle]                   ; Identificador del fichero
Linea:   PUSH CX
         mov ah,3fh                        ; Funcion lee datos de fichero
         mov dx,LineaBuf                   ; DS:DX buffer for data
         MOV ecx,[InfoHeader+biWidth]
         shl ecx,1
         add ecx,[InfoHeader+biWidth]      ; Bytes a LEER (Ancho*3) 24 bpp
         INT 21h                           ; Lee el bloque de bytes
         mov ecx,[InfoHeader+biWidth]
         mov edx,LineaBuf
L1:      mov eax,[ds:edx]
         mov [es:edi],eax
         add edx,3
         add edi,[BPP]                     ; BPP puede ser 3 o 4
         loop L1
         sub edi,[AnchuraX]
         sub edi,[WIDTHX_por_BPP]
         POP CX
         LOOP Linea                        ; Hasta terminar todas las lineas

        ; Paso 5 y ltimo: Cierro el fichero.

         MOV AH,3Eh
         INT 21h                           ; Cierra el fichero DOS
         JC HuboError
         JMP Fin             ; Si llega hasta aqu es que todo fue bien...
HuboError:                   ; En AX est el cdigo de error.
         MOV AH,02h
	 MOV DL,07h
 	 INT 21h              ; Si hubo error, que de un pitido
Fin:     popad
         pop es
         pop ds
         RETF

; -------------------------------------------------------------------------
[GLOBAL ModoTexto]
ModoTexto:
	 MOV AH,00h
	 MOV AL,03h
	 INT 10h                ; Texto 80x25 16 colores
         RETf

; -------------------------------------------------------------------------
[GLOBAL ShowBMP]
ShowBMP:
         ; La rutina ShowBMP solo necesita conocer el modo grfico VESA
         ;  en el que se va a visualizar
         ; Entrada :  CX = MODO VESA (LFB)
         ;            DS:DX = Dir nombre del fichewro .BMP
         push ds
         push dx                        ; Guarda la direccin del nombre
                                        ;  del fichero .BMP
         mov ax,_DATA
         mov ds,ax
         mov es,ax
         mov di,DatosVESA               ; ES:DI = ModeInfoBlock structure
         mov ax,4f01h                   ; AX    = 4F01h
         int 10h                        ; CX    = Mode number
         cmp ax,004fh
         jne sal1                       ; Si error salgo

         xor ebx,ebx
         mov bl,[DatosVESA+BitsPerPixel]
         shr ebx,3                      ; Divido entre 8
         mov [BPP],ebx

         xor eax,eax
         mov ax,[DatosVESA+BytesPerScanLine]
         mov [WIDTHX_por_BPP],eax

         xor dx,dx
         idiv bx
         mov [WIDTHX],eax

         mov edi,[DatosVESA+PhysBasePtr]

         mov ax,4f02h                   ; Set VBE Mode
         mov bx,cx
         int 10h
         cmp ax,004fh

sal1:    pop dx
         pop ds
         jne fin3                       ; Si error salgo

         call far LoadBMP               ; DS:DX = Dir. nombre fichero
                                        ; EDI   = Dir abs destino
         mov ecx,[BPP]
         mov edx,[WIDTHX]
fin3:    retf

; -------------------------------------------------------------------------
[GLOBAL LFBDir]
LFBDir:
         ; Input  CX  = Mode number
         ; Output EDI = Dir Physical  or 0 (error)
         ;        DX  = XResolution
         push es
         pushad

         mov ax,_DATA
         mov es,ax
         mov di,DatosVESA        ; ES:DI = ModeInfoBlock structure
         mov ax,4f01h                   ; AX    = 4F01h
         int 10h                        ; CX    = Mode number
         cmp ax,004fh
         popad

         jne sal2
         mov edi,[es:DatosVESA+PhysBasePtr]
         xor edx,edx
         mov dx,[es:DatosVESA+BytesPerScanLine]
         jmp fin2
sal2:    xor edi,edi
fin2:    pop es
         retf

; Segmento de DATOS -------------------------------------------------------
[SEGMENT _DATA CLASS=DATA]
ALIGN 16
FileHeader  resb 14                 ; BITMAPFILEHEADER {?}
InfoHeader  resb 40                 ; BITMAPINFOHEADER {?}
DatosVESA   resb 256                ; ModeInfoBlock {?}
Handle      DW  0
AnchuraX    DD  0
WIDTHX      DD  800
BPP         DD  4
WIDTHX_por_BPP DD 800*4
LineaBuf    resb 1600*4             ; Mxima resolucin 1600x1200x 32bpp

