; Autor : Jess Manuel Hernndez
; Fecha : Septiembre 1998
;
; Descripcin :
;
; Pone en modo FLAT y habilita la linea A20.
; Podemos acceder a toda la memoria fisica direccionable (4 Gb) sin
;  ningun problema.

[BITS 16]
; Segmento de CODIGO ------------------------------------------------------
[SEGMENT CODE]

[GLOBAL Flat386]
Flat386:
         push ds
         push es
         pushad                  ; Guardo los registros

         mov cx,ss
         xor eax,eax

  	 mov ax,_DATA
	 mov ds,ax
         shl eax,4               ; direccin lineal de segmento DS
         xor ebx,ebx
         mov ebx,GDT
         add eax,ebx             ; desplazamiento de GDT
         mov [ds:GDDIR],eax      ; guardar direccin lineal de GDT

         cli
         lgdt [ds:GDTR]          ; cargar tabla global de descriptores

         mov eax,cr0
         or  al,1
         mov cr0,eax

         jmp short $+2

         mov bx,2*8
         mov ds,bx               ; cargar registro de segmento DS
         mov es,bx               ; ES
         mov ss,bx               ; SS
         mov fs,bx               ; FS
         mov gs,bx               ; GS
         and al,11111110b
         mov cr0,eax             ; volver a modo real
         jmp short $+2           ; borrar cola de prebsqueda
         mov ss,cx
         sti

         mov ax,4300h
         int 2fh                 ; Busco HIMEM.SYS instalado ?
         cmp al,80h
         jnz Fin                 ; Si no est paso
         mov ax,4310h
         int 2fh                 ; ES:BX Rutina XMS
         mov ax,_DATA
         mov ds,ax
         mov [ds:dir],bx
         mov bx,es
         mov [ds:dir+2],bx
         mov bx,dir
         mov ah,05h
         call far [ds:dir]           ; Habilito A20

Fin:     popad
         pop es
         pop ds                  ; Recupero registros

         retf

; Segmento de DATOS -------------------------------------------------------

[SEGMENT _DATA CLASS=DATA]
ALIGN 16

GDTR     dw    3*8               ; Tamao de la GDT
GDDIR    dd    0                 ; Direccin de la GDT

GDT      DB    0,   0,   0,0,0,0,  0,   0       ; Descriptor 0 NULO
gcod     DB    0ffh,0ffh,0,0,0,9fh,0cfh,0       ; Descriptor 1 CODIGO
gdat     DB    0ffh,0ffh,0,0,0,93h,0cfh,0       ; Descriptor 2 DATOS,PILA

dir      resd 1
