	DOSSEG
	.MODEL LARGE
	.386p

	.CODE
	PUBLIC _ExistePCIBIOS, _BuscarDisp, _LeerPCIDW, _EscribirPCIDW
	PUBLIC _LeerPCIB, _EscribirPCIB

_ExistePCIBIOS PROC FAR
	push	bx cx dx
	mov	ax,0b101h
	int	1ah
	xor	al,al		; Si AH=00 -> PCIBIOS instalado
	pop	dx cx bx
	retf
_ExistePCIBIOS ENDP


_BuscarDisp PROC FAR, Device:WORD, Vendor:WORD, BusDevFun:WORD
	push	bp
	mov	bp,sp
	push	bx cx dx si
	xor	si,si
NEXT_DEVICE:
	mov	cx,Device
	mov	dx,Vendor
	mov	ax,0b102h
	int	1ah
	jnc	ENCONTRADO
	inc	si
	cmp	si,512d
	jne   NEXT_DEVICE
	; No encontrado
	mov	ax,1
	jmp	FIN_BUSCAR
ENCONTRADO:
	mov	si,BusDevFun
	mov	[si],bx
	xor	ax,ax
FIN_BUSCAR:
	pop	si dx cx bx
	mov	sp,bp
	pop	bp
	retf
_BuscarDisp  ENDP


; Lee un DWord del BIOS PCI
_LeerPCIDW	PROC	FAR, BusDevFun:WORD, NumReg:WORD, Dato:WORD
	push	bp
	mov	bp,sp
	push	bx cx dx
	mov	ax,0b10ah
	mov	bx,BusDevFun
	mov	di,NumReg	; (0000h-00ffh)
	int	1ah
	mov	si,Dato
	mov	[si],ecx
	xor	al,al
	pop	dx cx bx
	mov	sp,bp
	pop	bp
	retf
_LeerPCIDW	ENDP


; Escribe un DWord en el BIOS PCI
_EscribirPCIDW	PROC	FAR, BusDevFun:WORD, NumReg:WORD, Dato:DWORD
	push	bp
	mov	bp,sp
	push	bx cx dx
	mov	ax,0b10dh
	mov	bx,BusDevFun
	mov	di,NumReg	; (0000h-00ffh)
	mov	ecx,Dato
	int	1ah
	xor	al,al
	pop	dx cx bx
	mov	sp,bp
	pop	bp
	retf
_EscribirPCIDW	ENDP

; Lee un Byte del BIOS PCI
_LeerPCIB	PROC	FAR, BusDevFun:WORD, NumReg:WORD, Dato:WORD
	push	bp
	mov	bp,sp
	push	bx cx dx
	mov	ax,0b108h
	mov	bx,BusDevFun
	mov	di,NumReg	; (0000h-00ffh)
	int	1ah
	mov	si,Dato
	mov	[si],cl
	xor	al,al
	pop	dx cx bx
	mov	sp,bp
	pop	bp
	retf
_LeerPCIB	ENDP

; Escribe un Byte en el BIOS PCI
_EscribirPCIB	PROC	FAR, BusDevFun:WORD, NumReg:WORD, Dato:BYTE
	push	bp
	mov	bp,sp
	push	bx cx dx
	mov	ax,0b10bh
	mov	bx,BusDevFun
	mov	di,NumReg	; (0000h-00ffh)
	mov	cl,Dato
	int	1ah
	xor	al,al
	pop	dx cx bx
	mov	sp,bp
	pop	bp
	retf
_EscribirPCIB	ENDP

END